OpenKey         proc    near

                push    dx
                push    ax

                mov     al,05h
                call    GetSeq
                mov     bl,ah
                mov     ax,8605h
                call    SetReg

                pop     ax
                pop     dx
                ret

OpenKey         endp



CloseKey        proc    near

                push    dx
                push    ax

                mov     ax,0005h
                cmp     bl,0A1h
                je      @F
                call    SetSeq

@@:             pop     ax
                pop     dx
                ret

CloseKey        endp



SetWriteBank    proc    near

                push    dx
                push    ax

                mov     al,dl
                mov     dx,WRITEBANKREG
                out     dx,al

                pop     ax
                pop     dx
                ret

SetWriteBank    endp



SetReadBank     proc    near

                push    dx
                push    ax

                mov     al,dl
                mov     dx,READBANKREG
                out     dx,al

                pop     ax
                pop     dx
                ret

SetReadBank     endp



ClearSetBank:   xor     dx,dx
SetBank         proc    near
                call    SetWriteBank
                call    SetReadBank
                ret

SetBank         endp



ClearExtBank:   xor     dx,dx
SetExtBank      proc    near

                push    dx
                and     dh,003h
                mov     al,01Dh
                mov     ah,dh
                shl     dh,04h
                or      ah,dh
                call    SetSeq
                pop     dx

                call    SetBank
                ret

SetExtBank      endp



GetModeIndex    proc    near

                push    si
                push    cx
                push    ax

                mov     si, offset MD03_400
                mov     di,word ptr cs:[si+St_ModeFlag]
                and     di,ModeInfoFlag
                shl     di,1

                pop     ax
                pop     cx
                pop     si
                ret

GetModeIndex    endp



;---------------
;
;       Exits()
;
;---------------
Exits           proc    near

                ret

Exits           endp



;-------------------------------
;
;       GetTextCharAddr()
;
;       Input:
;          bh -> page number
;       Output:
;          di -> screen address
;
;-------------------------------
GetTextCharAddr proc    near

                mov     es,word ptr cs:B8000Sel
                test    byte ptr EQUIP_FLAG,10h
                jz      short @F
                mov     es,word ptr cs:B0000Sel
@@:             push    ax

                mov     bl,bh
                xor     bh,bh
                mov     ax,word ptr CRT_LEN
                mul     bx
                mov     di,ax
                shl     bx,1
                mov     bx,word ptr CURSOR_POSN[bx]
                mov     al,byte ptr CRT_COLS
                mul     bh
                xor     bh,bh
                add     ax,bx
                shl     ax,1
                add     di,ax

                pop     ax
                ret

GetTextCharAddr endp

;----------------------------------
;
;       GetExtCharAddr()
;
;       Input:
;          bh -> page number
;       Output:
;          dx:di -> screen address
;          bx -> next line offset
;          cx -> char height
;
;----------------------------------
GetExtCharAddr  proc    near

                mov     es,word ptr cs:A0000Sel
                push    ax

                mov     bl,bh
                xor     bh,bh
                mov     ax,word ptr CRT_LEN
                mul     bx
                movzx   esi,ax

                shl     bx,1
                movzx   ebx,word ptr CURSOR_POSN[bx]
                mov     al,byte ptr CRT_COLS
                mul     bh
                mul     word ptr POINTS
                xor     bh,bh
                mov     di,dx
                shl     edi,16
                mov     di,ax
                add     edi,ebx
                shl     edi,cl
                add     edi,esi

                movzx   ebx,word ptr CRT_COLS
                mov     cx,word ptr POINTS

                pop     ax
                ret

GetExtCharAddr  endp


GetDRAMType     proc    near

                push    dx
                push    ax

                movzx   bx,byte ptr cs:SoftSetting
                test    bl,SoftDRAMType
                jnz     short @F

ifdef           SIS300
                mov     al,03Ah
else
                mov     al,01Ah
endif
                call    GetSeq
                mov     bl,ah

@@:             and     bl,007h
                pop     ax
                pop     dx
                ret

GetDRAMType     endp

