SetMode         proc    near

                cli
                sub     sp,sizeof SetMode_Struct
                mov     bp,sp

                mov     ah,al
                and     ax,807Fh
                push    cs
                pop     es

                call    OpenKey
                mov     si, offset MD03_400
                mov     byte ptr ss:[bp+Set_SetFlag],0
                call    GetVBInfo
                call    SetCRT1Group
                call    CloseKey

SetModeRet:     add     sp,sizeof SetMode_Struct
                sti
                ret

SetMode         endp

GetVBInfo       proc    near

                push    bx
                push    ax
                mov     bx,word ptr cs:[si+St_ModeFlag]
                and     bl,ModeInfoFlag
                mov     byte ptr ss:[bp+Set_ModeType],bl
                xor     bx,bx
                mov     word ptr ss:[bp+Set_VBInfo],bx
                mov     byte ptr ss:[bp+Set_CRT1ModeID],ah
                mov     byte ptr ss:[bp+Set_LCDResInfo],0
                mov     byte ptr ss:[bp+Set_LCDTypeInfo],0
                mov     byte ptr ss:[bp+Set_LCDInfo],0
                pop     ax
                pop     bx
                ret

GetVBInfo       endp

SetCRT1Group    proc    near

                push    ax
                call    SaveModeID
                mov     di, offset cs:MD_2_3_400
                call    SetBIOSData

                call    SetSeqRegs
                call    SetMiscReg
                call    SetCRTCRegs
                call    SetATTRegs
                call    SetGRCRegs
                call    ClearExt1Regs

                call    SetCRT1FIFO
                call    SetCRT1ModeRegs

                call    LoadCharacter
                call    LoadDAC
                call    ClearBuffer

                pop     ax
                ret

SetCRT1Group    endp



SaveModeID      proc    near

                mov     byte ptr CRT_MODE,al            ; ModeID
                and     byte ptr EGA_INFO,07Fh
                or      byte ptr EGA_INFO,ah            ; reflect ModeID D[7]
                and     byte ptr EGA_INFO,not 008h      ; active VGA
                ret

SaveModeID      endp

SetBIOSData     proc    near

                push    di

                mov     al,byte ptr ss:[bp+Set_ModeType]
                shl     al,4
                mov     byte ptr SWITCHES,al

                mov     al,byte ptr CRT_MODE
                or      byte ptr EQUIP_FLAG,030h
                call    ModeType
                jne     short SetColorData
SetMonoData:    mov     word ptr ADDR_6845,MONO_INDEX
                or      byte ptr EGA_INFO,002h
                or      byte ptr SWITCHES,00Bh
                jmp     short @F
SetColorData:   xor     byte ptr EQUIP_FLAG,010h
                mov     word ptr ADDR_6845,COL_INDEX
                and     byte ptr EGA_INFO,not 002h
                or      byte ptr SWITCHES,008h
                test    byte ptr VGA_INFO,080h
                jnz     short @F
                or      byte ptr SWITCHES,001h

@@:             xor     cx,cx
                mov     word ptr CRT_START,cx
                mov     byte ptr ACTIVE_PAGE,cl
                mov     bx,8*2-1
ClearCursorLp:  mov     byte ptr CURSOR_POSN[bx],cl
                dec     bx
                jge     short ClearCursorLp

                movzx   bx,al

@@:             mov     word ptr CRT_LEN,cx
                mov     word ptr CURSOR_MODE,cx

                mov     cl,byte ptr cs:[di]
                cmp     cl,0FFh
                jne     short @F
                mov     cx,0100h
@@:             mov     word ptr CRT_COLS,cx
                xor     cx,cx
                mov     cl,byte ptr cs:[di+1]
                mov     byte ptr ROWS,cl
                mov     cl,byte ptr cs:[di+2]
                mov     word ptr POINTS,cx

                mov     cx,word ptr cs:[di+3]
                mov     word ptr CRT_LEN,cx
                mov     cx,word ptr cs:[di+20]
                xchg    ch,cl
                mov     word ptr CURSOR_MODE,cx

                cmp     bl,007h
                ja      short SetBIOSDataRet
                mov     cl,byte ptr cs:MODE_3X8_ARRAY[bx]
                mov     byte ptr CRT_MODE_SET,cl
                mov     cl,030h
                cmp     bl,006h
                jne     short SetBIOSPalete
                mov     cl,03Fh
SetBIOSPalete:  mov     byte ptr CRT_PALETTE,cl

SetBIOSDataRet: pop     di
                add     di,05h
                ret

SetBIOSData     endp

MODE_3X8_ARRAY  LABEL   BYTE
                db      02Ch,028h,02Dh,029h,02Ah,02Eh,01Eh,029h

SetSeqRegs      proc    near

                mov     ax,0300h                ; set normal
                call    SetSeq
                mov     al,001h
                mov     ah,byte ptr es:[di]
                inc     di
                call    SetReg
                mov     bx,00402h
                call    SetBlock
                ret

SetSeqRegs      endp


SetMiscReg      proc    near

                mov     dx,MISCREG
                mov     al,byte ptr cs:[di]
                inc     di
                out     dx,al
                ret

SetMiscReg      endp

SetCRTCRegs     proc    near

                call    UnLockCR0ToCR7          ; unlock cr0-7
                mov     bx,01800h
                call    SetBlock
                ret

SetCRTCRegs     endp

SetATTRegs      proc    near

                push    es
                push    si


                call    ResetATTR               ; reset attr. regs

                mov     ch,byte ptr VGA_INFO
@@:             mov     dx,ATTREG
                mov     bx,01300h
SetATTRLoop:    cmp     bl,00Fh
                jbe     short SetATTRCnt1
                cmp     bl,011h
                jne     short SetATTRCnt2
SetATTRCnt1:    test    ch,008h                 ; default palette loading
                jnz     short SetATTRCnt3
SetATTRCnt2:    mov     al,bl
                out     dx,al
                mov     al,byte ptr cs:[di]
@@:             out     dx,al
SetATTRCnt3:    inc     di
                inc     bl
                cmp     bl,bh
                jbe     short SetATTRLoop

                mov     al,14h
                out     dx,al
                xor     al,al
                out     dx,al

                test    byte ptr EGA_INFO,080h  ; check if clear buffer
                jz      short @F
                cmp     byte ptr ss:[bp+Set_CRT1ModeID],03h
                jne     short @F
                cmp     byte ptr CRT_Mode,13h
                je      short SetATTRet

@@:             call    EnableATTR              ; enable attr.

SetATTRet:      pop     si
                pop     es
                ret

SetATTRegs      endp

SetGRCRegs      proc    near

                mov     dx,GRC_INDEX
                mov     bx,00800h
                call    SetBlock

                cmp     byte ptr ss:[bp+Set_ModeType],ModeVGA
                jbe     short @F
                mov     ax,0BF05h               ; for Hi/True color modes
                call    SetRegAND
@@:             ret

SetGRCRegs      endp



;--------------------------------------------------------------------
;
;       ClearExt1Regs()
;
;       Description:
;         1. Clear related extended regs
;
;--------------------------------------------------------------------
ClearExt1Regs   proc    near

                mov     cx,0Eh-0Ah+1
                mov     ax,0000Ah
@@:             call    SetSeq
                inc     al
                loop    short @B
                ret

ClearExt1Regs   endp



;--------------------------------------------------------------------
;
;       SetCRT1Sync()
;
;       Description:
;         1. Set CRT1 Polarity
;       Input:
;         di -> pointer to setting parameter
;
;--------------------------------------------------------------------
SetCRT1Sync     proc    near

                mov     ax,word ptr cs:[di+Ext_InfoFlag]
                and     ah,0C0h
                mov     al,02Fh
                or      al,ah
                mov     dx,MISCREG
                out     dx,al
                ret

SetCRT1Sync     endp



;--------------------------------------------------------------------
;
;       SetDisplayUnit()
;
;       Description:
;         1. DisplayUnit=PixelPerScanLine*BytePerPixel/64+1
;       Input:
;         di -> pointer to setting parameter
;         cx -> offset data(CRT1)
;
;--------------------------------------------------------------------
SetDisplayUnit  proc    near

                test    word ptr cs:[di+Ext_InfoFlag],InterlaceMode
                jz      short @F
                shr     cx,1

@@:             mov     ax,cx
                shl     ax,8-3
                or      al,al
                jz      short @F
                inc     ah
@@:             inc     ah
                mov     al,010h
                call    SetSeq
                ret

SetDisplayUnit  endp



ifndef          SIS300                          ;;540/630 only
;--------------------------------------------------------------------
;
;       SetCRT1ECLK()
;
;       Description:
;         1. Reset ECLK for Waveform Problem (H/W Request)
;       Input:
;         di -> pointer to setting parameter
;
;--------------------------------------------------------------------
SetCRT1ECLK     proc    near

                push    di

ifdef           SIS540
                mov     di,offset cs:ECLK_90                    ;; [ynlai] 04/13/00
                call    GetRevisionID
;;;             and     al, 0f0h
                cmp     al, 00h
                jz      short SetECLKCnt
endif

                mov     ax,word ptr cs:[di+Ext_InfoFlag]        ;; ECLK 100
                and     ah,007h                                 ;; [ynlai] 04/13/00
;;              mov     ah,byte ptr cs:[di+Ext_CRT1CRTC]        ;; ECLK 115
;;              and     ah,0C0h
;;              shr     ah, 6
;;;             mov     ah,byte ptr cs:[di+Ext_CRTVCLK]         ;; ECLK 133
;;;             and     ah,0C0h
;;;             shr     ah, 6
                cmp     byte ptr CRT_MODE,013h
                ja      SHORT @F
                mov     ah, 00h
@@:
                mov     di,offset cs:ECLKData                   ;; ECLK 100
;;              mov     di,offset cs:ECLK115Data                ;; ECLK 115
;;;             mov     di,offset cs:ECLK133Data                ;; ECLK 133
                mov     al,5
                mul     ah
                add     di,ax
SetECLKCnt:
                mov     bx,0302Eh
                call    SetBlock

                pop     di
                ret

SetCRT1ECLK     endp

ifdef           SIS540
ECLK_90         db      038h,042h,080h          ; 81-83,index 1
                dw      90                      ; 84-85
endif

endif



SetCRT1FIFO     proc    near

                mov     bx,1
                inc     bl

                mov     ah,bl
                shl     ah,4
                or      ah,00Fh
                mov     al,008h
                call    SetSeq

                push    bx
                and     bl,010h
                shl     bl,1
                mov     ah,bl
                mov     al,00Fh
                mov     bl,not 060h
                call    SetRegANDOR
                pop     bx

                add     bl,003h
                mov     ah,bl
                mov     al,009h
                call    SetReg
                ret

SetCRT1FIFO     endp



;--------------------------------------------
;
;       SetCRT1ModeRegs()
;
;       Input:
;         di -> pointer to setting parameter
;
;--------------------------------------------
SetCRT1ModeRegs proc    near

                push    di

                mov     ax,03F1Fh
                call    SetSeqAND

                mov     cx,word ptr cs:[di+Ext_InfoFlag]
                xor     cx,cx

                mov     bl,byte ptr ss:[bp+Set_ModeType]
                xor     ah,ah
                mov     al,006h
                mov     bl,not 03Fh
                call    SetSeqANDOR

                mov     ax,0000Fh
                mov     bl,not 048h
                call    SetRegANDOR

                mov     ax,06021h
                mov     bl,not 0E0h
                call    SetRegANDOR


                pop     di
                ret

SetCRT1ModeRegs endp






;--------------------------------------------------
;
;       LoadCharacter()
;
;       Input:
;         si -> setting mode 1's parameter pointer
;
;--------------------------------------------------
LoadCharacter   proc    near

                push    es
                push    ds
                pusha


TextChar:       mov     ah,02h
                cmp     byte ptr POINTS,09h
                jbe     short @F
                mov     ah,01h
                cmp     byte ptr POINTS,0Eh
                jbe     short @F
                mov     ah,04h
@@:             xor     bl,bl
;                or      eax,010000h
                call    LoadTextFont
                jmp     short LoadCharRet


SetCharVector:  mov     word ptr INT43H,bx
                mov     word ptr INT43H+2,cs

LoadCharRet:    popa
                pop     ds
                pop     es
                ret

LoadCharacter   endp



;--------------------------------------------------
;
;       LoadDAC()
;
;       Input:
;         si -> setting mode 1's parameter pointer
;
;--------------------------------------------------
LoadDAC         proc    near

                push    es
                push    ds
                pusha

                mov     bx,word ptr cs:[si+St_ModeFlag]
                and     bl,DACInfoFlag
                mov     cx,64
                mov     si,offset cs:EGA_DAC
                call    WriteDAC

                test    byte ptr VGA_INFO,08h
                jnz     short LoadDACRet
                test    byte ptr VGA_INFO,06h
                jz      short LoadDACRet
                xor     bx,bx
                mov     cx,256
;;              call    DACToGray

LoadDACRet:     popa
                pop     ds
                pop     es
                ret

LoadDAC         endp



;--------------------------------------------------------------------
;
;       ClearBuffer()
;
;       Description:
;         1. Clear Video Buffer if Necessary
;
;--------------------------------------------------------------------
ClearBuffer     proc    near

                push    es
                pusha
                call    ClearTextBuffer
                popa
                pop     es
                ret

ClearBuffer     endp


;----------------------------------------
;
;       LoadTextFont()
;
;       Input:
;         ah = 00 User Load
;                 es:bp -> Font data
;                 cx -> Char Number
;                 bl -> Char Map number
;                 bh -> Char height
;                 dx -> Start ASCII Code
;            = 01 Load 8x14 Font
;                 bl = Char Map number
;            = 02 Load 8x8 Font
;                 bl = Char Map number
;            = 04 Load 8x16 Font
;                 bl = Char Map number
;
;          eax(b16) = 0 Load x8 Font
;                     1 Load x9 Font
;
;-------------------------------------------
LoadTextFont    proc    near

                push    ds

                or      ah,ah
                jnz     short LoadBIOSFont
LoadUserFont:   mov     ax,es
                jmp     short SetupChar

LoadBIOSFont:   mov     si,offset cs:FONT8X16
                mov     bh,0Eh

                mov     bh,10h
@@:             xor     dx,dx
                mov     cx,0100h
                mov     ax,cs

SetupChar:      push    cx
                mov     ch,bl
                and     ch,03h
                shl     ch,01h
                test    bl,04h
                jz      short @F
                inc     ch
@@:             add     dh,ch
                shl     dx,5
                pop     cx
                mov     di,dx
                or      cx,cx
                jz      LoadFontRet
                mov     ds,ax

                call    OpenCharMap

                mov     es,word ptr cs:A0000Sel
MoveCharsLoop:  push    di
                push    cx
                movzx   cx,bh
                rep     movsb
                pop     cx
                pop     di
                add     di,020h
                loop    MoveCharsLoop

LoadFontRet:    pop     ds
                call    CloseCharMap
                ret

LoadTextFont    endp



;---------------------
;
;       OpenCharMap()
;
;---------------------
OpenCharMap     proc    near

                mov     ax,0402h
                call    SetSeq
                mov     ax,0704h
                call    SetReg
                mov     dx,GRC_INDEX
                mov     ax,0005h
                call    SetReg
                mov     ax,0406h
                call    SetReg
                mov     ax,0204h
                call    SetReg
                ret

OpenCharMap     endp



;----------------------
;
;       CloseCharMap()
;
;----------------------
CloseCharMap    proc    near

                mov     ax,0302h
                call    SetSeq
                mov     ax,0304h
                call    SetReg
                mov     dx,GRC_INDEX
                mov     ax,1005h
                call    SetReg
                mov     ax,0E06h
                cmp     word ptr ADDR_6845,COL_INDEX
                je      short @F
                mov     ax,0A06h
@@:             call    SetReg
                mov     ax,0004h
                call    SetReg
                ret

CloseCharMap    endp

;-----------------------------------
;
;       WriteDAC()
;
;       Input:
;         si -> RAMDAC data pointer
;
;-----------------------------------
WriteDAC        proc    near

                push    bp


@@:             mov     dx,PELMASK
                mov     al,0FFh
                out     dx,al
                mov     dx,PELWRITE
                xor     al,al
                out     dx,al
                mov     bp,PELDATA

WriteDACCnt:    mov     dx,bp
                push    cx
                shl     ch,4
                or      cl,ch
                xor     ch,ch
DAC16Loop1:     mov     bh,byte ptr cs:[si]
                inc     si
                mov     bl,03h
DAC16Loop2:     xor     al,al
                test    bh,01h
                jz      short @F
                mov     al,2Ah
@@:             test    bh,02h
                jz      short @F
                add     al,15h
@@:             cmp     dx,PELDATA
                je      short @F
                shl     al,2
@@:             out     dx,al
                shr     bh,2
                dec     bl
                jnz     short DAC16Loop2
                loop    DAC16Loop1
                pop     cx
                or      ch,ch
                jz      short WriteDACRet

                mov     cx,16
DAC256GreyLp1:  mov     al,byte ptr cs:[si]
                cmp     dx,PELDATA
                je      short @F
                shl     al,2
@@:             inc     si
                mov     bl,03h
DAC256GreyLp2:  out     dx,al
                dec     bl
                jnz     short DAC256GreyLp2
                loop    DAC256GreyLp1

                mov     cx,09h
DAC256Loop1:    push    cx
                mov     di,si
                mov     bx,si
                add     bx,04h

                xor     dl,dl
                mov     cx,03h
DAC256Loop2:    push    cx

                mov     cx,05h
@@:             mov     dh,byte ptr cs:[si]
                mov     ah,byte ptr cs:[di]
                mov     al,byte ptr cs:[bx]
                inc     si
                call    Write256DAC
                loop    short @B

                sub     si,2
                mov     cx,03h
@@:             mov     dh,byte ptr cs:[bx]
                mov     ah,byte ptr cs:[di]
                mov     al,byte ptr cs:[si]
                dec     si
                call    Write256DAC
                loop    short @B

                pop     cx
                inc     dl
                loop    DAC256Loop2

                pop     cx
                add     si,05h
                loop    DAC256Loop1

WriteDACRet:    pop     bp
                ret

WriteDAC        endp



;-----------------------------
;
;       Write256DAC()
;
;       Input:
;         bp -> DAC Data Port
;         dl = 0
;              dh = R Value
;              ah = G Value
;              al = B Value
;         dl = 1
;              dh = G Value
;              ah = B Value
;              al = R Value
;         dl = 1
;              dh = B Value
;              ah = R Value
;              al = G Value
;
;-----------------------------
Write256DAC     proc    near

                push    dx
                push    bx

                mov     bx,ax
                or      dl,dl
                jz      short Write256DACCnt
                xchg    dh,bh
                cmp     dl,01h
                jne     short @F
                xchg    dh,bl
                jmp     short Write256DACCnt
@@:             xchg    bh,bl

Write256DACCnt: cmp     bp,PELDATA
                je      short @F
                shl     dh,2
                shl     bx,2
@@:             mov     al,dh
                mov     dx,bp
                out     dx,al
                jmp     $+2
                mov     al,bh
                out     dx,al
                jmp     $+2
                mov     al,bl
                out     dx,al
                jmp     $+2

                pop     bx
                pop     dx
                ret

Write256DAC     endp






;--------------------------------------------------------------------
;
;       ClearTexBuffer()
;       ClearCGABuffer()
;
;       Description:
;         1. Clear Text/CGA Buffer
;
;--------------------------------------------------------------------
ClearTextBuffer proc    near

                mov     ax,00720h               ; clear data for text mode
                mov     es,word ptr cs:B8000Sel ; for VGA active mode
                test    byte ptr EQUIP_FLAG,10h
                jz      short @F
                mov     es,word ptr cs:B0000Sel ; for non-VGA active mode
@@:             mov     cx,4000h                ; clear buffer size=32K bytes
                xor     di,di
                rep     stosw
                ret

ClearTextBuffer endp



