; Programmer: Johnny Pan
; Date: 01/20/99 - 08/13/99
; Filename: VGAFUN0E.ASM
;
;               +-----------------------+
;               |  FUNC 0E - WRITE TTY  |
;               +-----------------------+
;
;----------------------------
;
;       VGAFun0E()
;
;       Input:
;          al -> char code
;          bl -> color
;
;----------------------------
VGAFun0E        proc

                mov     bh,byte ptr ACTIVE_PAGE
                movzx   di,bh
                shl     di,1
                mov     dx,word ptr CURSOR_POSN[di]

                call    WriteTTY
                jz      short @F
                call    WriteTTYChar
@@:             call    UpdateCursor
VGAFun0ERet:    ret

VGAFun0E        endp



;------------------
;
;       WriteTTY()
;
;------------------
WriteTTY        proc    near

                cmp     al,07h
                jne     short @F
                call    SndSpeaker
                jmp     short SetTTYFlag

@@:             cmp     al,08h
                jne     short @F
                or      dl,dl
                jz      short SetTTYFlag
                dec     dl
                jmp     short SetCursorPos

@@:             cmp     al,0Ah
                je      short SetIncRow

                cmp     al,0Dh
                jne     short WriteTTYRet
                xor     dl,dl
                jmp     short SetCursorPos

UpdatePos:      inc     dl
                cmp     dl,byte ptr CRT_COLS
                jb      short SetCursorPos
                xor     dl,dl
SetIncRow:      inc     dh
                cmp     dh,byte ptr ROWS
                jbe     short SetCursorPos
                mov     dh,byte ptr ROWS
                call    ScrollScreen
SetCursorPos:   mov     word ptr CURSOR_POSN[di],dx

SetTTYFlag:     xor     al,al
                or      al,al
WriteTTYRet:    ret

WriteTTY        endp



;----------------------
;
;       WriteTTYChar()
;
;----------------------
WriteTTYChar    proc    near

                push    ds
                pusha
                mov     cx,0001h
                call    VGAFun0A
                popa
                pop     ds
                call    UpdatePos
                ret

WriteTTYChar    endp



;----------------------
;
;       UpdateCursor()
;
;----------------------
UpdateCursor    proc    near

                ret

UpdateCursor    endp



;----------------------
;
;       ScrollScreen()
;
;----------------------
ScrollScreen    proc    near

                push    es
                push    ds
                pusha

                mov     word ptr CURSOR_POSN[di],dx
                xor     bh,bh
                cmp     byte ptr CRT_MODE,003h
                jbe     short @F
                cmp     byte ptr CRT_MODE,007h
                jne     short ScrollScreenCnt
@@:             mov     bh,byte ptr ACTIVE_PAGE

ScrollScreenCnt:mov     ax,00601h
                xor     cx,cx
                mov     dh,byte ptr ROWS
                mov     dl,byte ptr CRT_COLS
                dec     dl
                int     10h

                popa
                pop     ds
                pop     es
                ret

ScrollScreen    endp



DATA8253        EQU     40H
SYS1            EQU     61H
;--------------------
;
;       SndSpeaker()
;
;--------------------
SndSpeaker      proc    near

                push    cx

                mov     al,0B6h
                out     DATA8253+3,al
                jmp     $+2
;                mov     ax,0400h               ;;[mars] 01/27/00
                mov     ax,0533h                ; change sound frequency
                out     DATA8253+2,al
                jmp     $+2
                mov     al,ah
                out     DATA8253+2,al
                jmp     $+2

                in      al,SYS1
                mov     ah,al
                or      al,3
                out     SYS1,al
                jmp     $+2

;                mov     al,002h                ;;[mars] 01/27/00
;SndSpeakerLp:   xor     cx,cx
;@@:             loop    @B
;                dec     al
;                jnz     SndSpeakerLp
                push    ax                      ; change delay time to 1 sec
                push    cx
                push    dx
                mov     cx,15
                mov     dx,16960
                mov     ah,86h
                int     15h
                pop     dx
                pop     cx
                pop     ax

                mov     al,ah
                out     SYS1,al

                pop     cx
                ret

SndSpeaker      endp
